//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#ifndef FButtonRoundH
#define FButtonRoundH
//---------------------------------------------------------------------------
#include <Buttons.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Forms.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <DBCtrls.hpp>
//---------------------------------------------------------------------------
class FButtonRound : public TGraphicControl
{
private:
    void PaintClicked();
    void PaintNormal();
    void PaintDisabled();
    void PaintMoved();
    void __fastcall SetCaption(AnsiString);
    AnsiString FCaption;
    int middlex;
    int middley;
    int cwidth;
    int cheight;
    bool clicked;
    Boolean FEnabled;
    void __fastcall SetEnabled(Boolean);
    enum TKind { Standard, Win95 };
    void __fastcall SetKind(TKind);
    bool mouseover;
    TKind FKind;
    POINT p;
    HMENU PM;
    void __fastcall SetFRMenu(Boolean);
    Boolean FRMenu;
protected:
    void __fastcall Paint();
    void __fastcall CMMouseEnter(TMessage *);
    void __fastcall CMMouseLeave(TMessage *);
    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
    void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
public:
	__fastcall FButtonRound(TComponent* Owner);
    void __fastcall SetBounds(int,int,int,int);
__published:
    __property AnsiString Caption = { read=FCaption, write=SetCaption, nodefault };
    __property OnClick ;
    __property OnMouseMove ;
    __property Visible ;
    __property Boolean Enabled = { read=FEnabled, write=SetEnabled, default=1 };
    __property Hint ;
    __property ShowHint ;
    __property Font ;
    __property TKind Kind = { read=FKind, write=SetKind, default=Standard };
    __property Boolean RightClickMenu = { read=FRMenu, write=SetFRMenu, default=true };
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
END_MESSAGE_MAP(TGraphicControl);
};
//---------------------------------------------------------------------------
#endif
